#!/usr/bin/env python

class C:
    def g(self):
        return self.f # C.f with context self
    def f(self): pass

    def test(self):
        self.f()
        self.g()

class D:
    f = C.f
    def g(self):
        return self.f # D.f with context preserved

    def test(self):
        self.f(2)
        self.g()

class E(C):
    def g(self):
        return self.f # C.f with context self

    def test(self):
        self.f()
        self.g()

C.f
D.f
E.f

c = C()
d = D()
e = E()

x = c.f # bound C.f   == c.g()
y = d.f # unbound C.f == d.g()
z = e.f # bound E.f   == e.g()

# vim: tabstop=4 expandtab shiftwidth=4
